#import <string.h>
#import "DAIsy.h"
#import "DAIsySound.h"

@implementation DAIsy

// ץꥱǥꥲ
-appDidInit:sender         // ץꥱ ˥饤
{
    [windowControle makeKeyAndOrderFront:self];
    
    [buttonPlay setEnabled:YES];
    [buttonRecord setEnabled:YES];
    [buttonStop setEnabled:YES];
    [buttonPause setEnabled:YES];

    [buttonPlay setState:0];
    [buttonRecord setState:0];
    [buttonStop setState:0];
    [buttonPause setState:0];

    [titlePlay setTextGray:NX_BLACK];
    [titleRecord setTextGray:NX_BLACK];
    [titleStop setTextGray:NX_BLACK];
    [titlePause setTextGray:NX_DKGRAY];

    [menuCompress setEnabled:NO];
    [menuDecompress setEnabled:NO];
    
    [infoVersionField setStringValue:"Version 0.20"];

    aSound=[self soundAlloc];                  // ɥ֥
        
    strcpy(path,NXHomeDirectory());            // ɥȥѥν
    strcpy(sndPath, path);
    strcat(sndPath,"/̤̾.snd");
    
    return self;
}

-appWillTerminate:sender   // ץꥱ λ
{
    [aSound stop];                     // ɤ
    [aSound free];                     // ɥ֥Ȥβ

    return self;
}


// ᥽å
- soundAlloc               // ɥ֥
{
// ɥ֥˥饤ǥꥲȤΥå
    return [[[DAIsySound alloc] init] setDelegate:self]; 
}

- compress:sender          // 
{
    if([aSound is16bitLinear] == NO)
    {
        NXRunAlertPanel("顼","̤ǤʤǤ" , 
                                                       NULL , NULL , NULL );
        return nil;
    }
    else if(snderr=[aSound convertToFormat:SND_FORMAT_COMPRESSED])
    {
        NXRunAlertPanel("顼","̤ǤޤǤ" , 
                                                       NULL , NULL , NULL );
        return nil;
    }
    
    [self soundFormatInfo:aSound];
    [self menuCompressDecompressAutoEnableSelect];
    return self;
}

- decompress:sender        // Ĺ
{
    if([aSound isCompressed] == NO)
    {
        NXRunAlertPanel("顼","ĹǤʤǤ" , 
                                                       NULL , NULL , NULL );
        return nil;
    }
    else if([aSound convertToFormat:SND_FORMAT_LINEAR_16])
    {
        NXRunAlertPanel("顼","ĹǤޤǤ" , 
                                                       NULL , NULL , NULL );
        return nil;
    }
    
    [self soundFormatInfo:aSound];
    [self menuCompressDecompressAutoEnableSelect];
    return self;
}

- documentAltSave:sender   // ̾ǥ
{
    id savePanel;
    char filename[BUFSIZ];
	
    strcpy(filename,strrchr(sndPath,'/')+1);	// ե͡
    savePanel=[SavePanel new];
    [savePanel setRequiredFileType:"snd"];
    if([savePanel runModalForDirectory:path file:filename])
    {
        strcpy(sndPath,[savePanel filename]);
	strcpy(path,[savePanel directory]);
        [windowControle setTitleAsFilename:sndPath];
        [aSound writeSoundfile:sndPath];
    } else
    {
        return nil;    // ּä
    }

    return self;
}

- documentOpen:sender      // ɥȤ򳫤
{
    id openPanel;
    int i;
    const char *const fileTypes[3]={"snd","SND",NULL};
    
    openPanel=[OpenPanel new];
    if([openPanel runModalForTypes:fileTypes])
    {
        strcpy(sndPath,[openPanel filename]);
	strcpy(path,[openPanel directory]);
    }
    else
    {
	return self;    // ץä
    }
    [aSound stop];
    // ɤɤ߹
    if((snderr=[aSound readSoundfile:sndPath]) != SND_ERR_NONE)
    {
        NXRunAlertPanel("","ɤ߹ߤ˼Ԥޤ",NULL,NULL,NULL);
        return nil;    // ץ
    }
    i=[aSound dataFormat];
    if(i != SND_FORMAT_LINEAR_16 && i != SND_FORMAT_COMPRESSED)
    {
	if([aSound isDSPFormat] == YES)
	{
	    snderr=[aSound convertToFormat:SND_FORMAT_LINEAR_16];
	    NXRunAlertPanel("",
	    "DSPΥǡ16bit LinearѴޤ" ,
                                                           NULL,NULL,NULL);
            goto tag;
	}
        if(NXRunAlertPanel("",
                     "fs=44.1kHz 16bit ˥Ѵޤ" ,
                                                    "Ѵ","ʤ",NULL))
        {
            // ɥեޥåѴ
            if(snderr=[aSound convertToFormat:SND_FORMAT_LINEAR_16
                                 samplingRate:SND_RATE_HIGH
                                 channelCount:2])
            {
                NXRunAlertPanel("顼","ѴǤޤǤ" , 
                                                         NULL , NULL , NULL );
                return nil;
	    }
	}
    }
tag:
    [self menuCompressDecompressAutoEnableSelect];

    [windowControle setTitleAsFilename:sndPath];

    [self soundFormatInfo:aSound];
    
    return self;
}

- pause:sender             // ݡ
{
    switch([aSound status])
    {
        case NX_SoundStopped            :
	                                 break;
        case NX_SoundRecording          :snderr=[aSound pause]; // ݡ
	                                 break;
        case NX_SoundPlaying            :snderr=[aSound pause]; // ݡ
	                                 break;
        case NX_SoundInitialized        :
	                                 break;
        case NX_SoundRecordingPaused    :snderr=[aSound record]; // ϿƳ
	                                 break;
        case NX_SoundPlayingPaused      :snderr=[aSound play];   // Ƴ
	                                 break;
        case NX_SoundRecordingPending   :
	                                 break;
        case NX_SoundPlayingPending     :
	                                 break;
        case NX_SoundFreed              :
	                                 break;
    }


    return self;
}

- play:sender              // 
{
    if([aSound isPlayable] == NO)
    {
        [buttonPlay setState:0];
	return nil;
    }
    [aSound play];	// ɺϡʥХå饦ư
    return self;
}

- record:sender            // Ͽ
{
/* ɬפʤ⤷ʤϿ˥֥Ȥľ */
    if(aSound)
    {
        if([aSound status] != NX_SoundStopped) [self stop:sender];
        [aSound free];
    }
    aSound=[self soundAlloc];      // ɥ֥
    
    // ɥ֥Ȥ
    [aSound setDAIsyRecordingFormatForCD_DA];   // CD-DAޤMD
    				
    snderr=[aSound record];	// ϿϡʥХå饦ư

    return self;
	
}

- stop:sender              // 
{
    [buttonPlay setEnabled:YES];
    [buttonRecord setEnabled:YES];
    [buttonStop setEnabled:YES];
    [buttonPause setEnabled:YES];

    [buttonPlay setState:0];
    [buttonRecord setState:0];
    [buttonStop setState:0];
    [buttonPause setState:0];

    [titlePlay setTextGray:NX_BLACK];
    [titleRecord setTextGray:NX_BLACK];
    [titleStop setTextGray:NX_BLACK];
    [titlePause setTextGray:NX_DKGRAY];
    
    [menuOpen setEnabled:YES];
    [menuAltSave setEnabled:YES];
    [self menuCompressDecompressAutoEnableSelect];

    switch([aSound status])
    {
        case NX_SoundStopped            :
	                                 break;
        case NX_SoundRecording          :snderr=[aSound stop];    // Ͽ
	                                 break;
        case NX_SoundPlaying            :snderr=[aSound stop];    // 
	                                 break;
        case NX_SoundInitialized        :
	                                 break;
        case NX_SoundRecordingPaused    :snderr=[aSound stop];
	                                 break;
        case NX_SoundPlayingPaused      :snderr=[aSound stop];
	                                 break;
        case NX_SoundRecordingPending   :snderr=[aSound stop];
	                                 break;
        case NX_SoundPlayingPending     :snderr=[aSound stop];
	                                 break;
        case NX_SoundFreed              :
	                                 break;
    }

    return self;

}

- soundFormatInfo:sndObj       // ɾɽ
{
    int w;
    double dw;
    char str[BUFSIZ];

    w=[sndObj sampleCount];                 // ץ
    sprintf(str,"%d",w);
    [fieldSmplCnt setStringValue:str];
    
    dw=(double)w/[sndObj samplingRate];
    sprintf(str,"%-7.2f",dw);
    [fieldTime setStringValue:str];
    
    w=[sndObj dataSize];                    // ǡ
    sprintf(str,"%d",w);
    [fieldSize setStringValue:str];
    
    dw=[sndObj samplingRate];               // ץ󥰥졼 
    sprintf(str,"%-7.2f",dw);
    [fieldRate setStringValue:str];

    w=[sndObj dataFormat];                  // ǡ
    switch(w)
    {
        case SND_FORMAT_DSP_DATA_16	:strcpy(str,"DSP DATA");
					 break;
        case SND_FORMAT_LINEAR_16	:strcpy(str,"16bit Linear");
					 break;
        case SND_FORMAT_MULAW_8		:strcpy(str,"8bit Mulaw");
					 break;
        case SND_FORMAT_COMPRESSED	:strcpy(str,"Compressed");
					 break;
        default				:strcpy(str,"Other");	
    }
    [fieldFormat setStringValue:str];

    return self;
}

- menuCompressDecompressAutoEnableSelect     // ̥˥塼
{
    if([aSound dataFormat] == SND_FORMAT_LINEAR_16)
    {
	[menuCompress setEnabled:YES];
        [menuDecompress setEnabled:NO];
    } else if([aSound dataFormat] == SND_FORMAT_COMPRESSED)
    {
	[menuCompress setEnabled:NO];
	[menuDecompress setEnabled:YES];
    } else 
    {
	[menuCompress setEnabled:NO];
	[menuDecompress setEnabled:NO];
    }
    return self;
}


// ɥǥꥲ
- willPlay:sender	// ľ
{
    [buttonPlay setEnabled:NO];
    [buttonRecord setEnabled:NO];
    [buttonStop setEnabled:YES];
    if([sender dataFormat] == SND_FORMAT_COMPRESSED)
    {
        [buttonPause setEnabled:NO];
    } 
    else [buttonPause setEnabled:YES];

    [buttonPlay setState:1];
    [buttonRecord setState:0];
    [buttonStop setState:0];
    [buttonPause setState:0];
    
    [titlePlay setTextGray:NX_BLACK];
    [titleRecord setTextGray:NX_DKGRAY];
    [titleStop setTextGray:NX_BLACK];
    if([sender dataFormat] == SND_FORMAT_COMPRESSED)
    {
        [titlePause setTextGray:NX_DKGRAY];
    } 
    else [titlePause setTextGray:NX_BLACK];
    
    [menuOpen setEnabled:NO];
    [menuAltSave setEnabled:NO];
    [menuCompress setEnabled:NO];
    [menuDecompress setEnabled:NO];
	
    // ɥ᡼
    [soundMeter setSound:[sender soundBeingProcessed]];
    [soundMeter run:self];
    return self;

}

- didPlay:sender	// λ
{
    [soundMeter stop:self];

    [buttonPlay setEnabled:YES];
    [buttonRecord setEnabled:YES];
    [buttonStop setEnabled:YES];
    [buttonPause setEnabled:NO];

    [buttonPlay setState:0];
    [buttonRecord setState:0];
    [buttonStop setState:0];
    [buttonPause setState:0];
    
    [titlePlay setTextGray:NX_BLACK];
    [titleRecord setTextGray:NX_BLACK];
    [titleStop setTextGray:NX_BLACK];
    [titlePause setTextGray:NX_DKGRAY];
    
    [menuOpen setEnabled:YES];
    [menuAltSave setEnabled:YES];
    [self menuCompressDecompressAutoEnableSelect];

    return self;
}

- willRecord:sender	// Ͽľ
{
    [buttonPlay setEnabled:NO];
    [buttonRecord setEnabled:NO];
    [buttonStop setEnabled:YES];
    [buttonPause setEnabled:NO];

    [buttonPlay setState:0];
    [buttonRecord setState:1];
    [buttonStop setState:0];
    [buttonPause setState:0];
    
    [titlePlay setTextGray:NX_DKGRAY];
    [titleRecord setTextGray:NX_BLACK];
    [titleStop setTextGray:NX_BLACK];
    [titlePause setTextGray:NX_DKGRAY];
    
    [menuOpen setEnabled:NO];
    [menuAltSave setEnabled:NO];
    [menuCompress setEnabled:NO];
    [menuDecompress setEnabled:NO];

    // ɥ᡼
    /* DSPϤǤϻѽʤ */
//    [soundMeter setSound:[sender soundBeingProcessed]];
//    [soundMeter run:self];
    return self;
}

- didRecord:sender	// Ͽλ
{
    [buttonPlay setEnabled:YES];
    [buttonRecord setEnabled:YES];
    [buttonStop setEnabled:YES];
    [buttonPause setEnabled:NO];

    [buttonPlay setState:0];
    [buttonRecord setState:0];
    [buttonStop setState:0];
    [buttonPause setState:0];
    
    [titlePlay setTextGray:NX_BLACK];
    [titleRecord setTextGray:NX_BLACK];
    [titleStop setTextGray:NX_BLACK];
    [titlePause setTextGray:NX_DKGRAY];
    
    [menuOpen setEnabled:YES];
    [menuAltSave setEnabled:YES];
    [self menuCompressDecompressAutoEnableSelect];

    if([sender isDSPFormat] == YES)  // եޥåѴ
    {
        // 16bit Linear Ѵ
        [sender convertToFormat:SND_FORMAT_LINEAR_16];
    }
    [self soundFormatInfo:sender];
    [menuCompress setEnabled:YES];
    [menuDecompress setEnabled:NO];

    return self;
}

- hadError:sender	// 顼ȯ
{
    NXRunAlertPanel("顼",SNDSoundError(snderr) , NULL , NULL , NULL );
    return self;
}

@end
